## Zope PostgreSQL DataBase Adapter based on PoPy Python Postgres Driver 
## --------------------------------------------------------------------- 

## Copyright (c) 2000 - Thierry MICHEL <thierry@nekhem.com> 
## Copyright (c) 2000 - MixadLive srl Torino, Italy 
## http://www.mixadlive.com 
## Copyright (c) 2000 - Nekhem Technologies
## http://www.nekhem.com 

## This library is free software, you can redistribute it and/or 
## modify it under the terms of the GNU General Public Licence as  
## published by the Free Software Foundation. 

## This program is distributed in the hope that it will be useful, 
## but WITHOUT ANY WARRANTY; without even the implied warranty of 
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
## GNU General Public License for more details 

## You should have received a copy of the GNU General Public License 
## along with this program; if not, write to the Free Software 
## Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA. 

## MixadLive, Srl., hereby disclaims all copyright 
## interest in the Zope Database Adapter `ZPoPyDA' written  
## by Thierry MICHEL 

## -- Thierry - Developer 
## For bugs & comments: thierry@nekhem.com 


database_type='PoPy'

"""%s Database Connection""" % database_type
__version__='$Revision: 1.3 $'[11:-2]

table_infos = """select  a.attnum,a.attname,
                   t.typname,a.attlen,a.attnotnull
                   from pg_attribute a, pg_type t, pg_class c
                   where 
                   c.relname = '%s' and 
                   a.attnum >0 and
                   a.attrelid = c.oid and
                   a.atttypid = t.oid
                   order by a.attnum """

table_infos2 = """select 
                   t1.typname AS basetable,
                   t2.typname AS reftable,
                   d.description,
                   r.tgnargs AS nargs,
                   r.tgargs AS arguments,
                   r.tgdeferrable AS deferrable,
                   r.tginitdeferred AS initiallydeferred,
                   r.tgconstrname AS constrname 
                   from pg_trigger r, pg_type t1, pg_type t2 ,pg_description d
                   where
                   t1.typname='%s'
                   and
                   d.description ~* 'referential integrity'
                   and
                   r.tgenabled='t'
                   and 
                   r.tgisconstraint ='t'
                   and
                   r.tgfoid = d.objoid
                   and
                   t1.typrelid=r.tgrelid
                   and
                   t2.typrelid=r.tgconstrrelid"""

table_infos3 = """SELECT x.indisprimary AS pkey,
                   pg_get_indexdef(x.indexrelid) AS indexdef
                   FROM pg_index x,
                   pg_class c, pg_class i
                   WHERE
                   ((c.oid = x.indrelid) AND
                   (i.oid = x.indexrelid)) AND
                   c.relname = '%s'
                   ;"""

from PoPy_db import DB
import Shared.DC.ZRDB.Connection
from App.Dialogs import MessageDialog
from Globals import HTMLFile
import Globals
import string
import OFS.SimpleItem, AccessControl.Role
from OFS.Image import Image

addConnectionForm=HTMLFile(
    'Products/ZPoPyDA/PoPyconnectionAdd',
    default_id='%s_database_connection' % database_type,
    default_title='Z %s Database Connection' % database_type,
    database_type=database_type,
    )

def addConnection(self, id, title, connection_string, connected=None,attempts=10,seconds=5,REQUEST=None):
    """Add a Z PoPy DB connection to a folder"""
        
    if not connected is None:
        connected = 1
    self._setObject(id, Connection(id, title,connection_string,connected,attempts,seconds))
    if REQUEST is not None: return self.manage_main(self,REQUEST)

class Connection(Shared.DC.ZRDB.Connection.Connection):
    """A database connection object"""
    database_type=database_type
    id='%s_database_connection' % database_type
    meta_type=title='Z %s Database Connection' % database_type
    icon='misc_/Z%sDA/conn' % database_type
    _isAnSQLConnection=1

    #ZPoPyDA_logo = Image('ZPoPyDA_logo','','Products/ZPoPyDA/logo.gif',content_type='image/gif')
    
    manage_options=Shared.DC.ZRDB.Connection.Connection.manage_options+(
        {'label':'Browser','action':'manage_browser'},
        )

    manage_browser = HTMLFile('PoPyconnectionBrowser',globals())
    
    def __init__(self, id, title, connection_string, connected=None,attempts=10,seconds=5):
        self.id=id
        self.edit(title, connection_string, connected)
        self.attempts = attempts
        self.seconds = seconds
        
        if self._v_connected:
            self._v_database_connection.setAttempts(attempts,seconds)

    def __is_foreign_key(self,description):
        res=1
        if string.find(description,'FOREIGN') == -1:
            res=0
        return res

    def __get_source_table(self,arguments):
        res=''
        res= string.split(arguments,'\\000')[2]

        return res

    def __get_source_field(self,arguments):
        res=''
        res= string.split(arguments,'\\000')[4]

        return res

    def __set_table_fkeys(self,tablename):
        if self._v_connected:
            o,records = self._v_database_connection.query(table_infos2 % tablename)

        self.fkeys = []
        for r in records:
            if self.__is_foreign_key(r[2]):
                info = (self.__get_source_table(r[4]),self.__get_source_field(r[4]))
                self.fkeys.append(info)
                

    def __set_table_pkeys(self,tablename):
        if self._v_connected:
            o,records = self._v_database_connection.query(table_infos3 % tablename)

        self.pkeys = []
        from re import search
        from string import split
        for r in records:
            if r[0] == 1:
                rgx = search('\(.*\)',r[1])
                info = split(rgx.string[rgx.regs[0][0]+1:rgx.regs[0][1]-1],' ')
                for i in range(0,len(info),2):
                    self.pkeys.append(info[i])

                
    def is_primary_key(self,field):
        if field in self.pkeys:
            return 1
        return 0
    
    def is_foreign_key(self,field):
        for i in self.fkeys:
            if field in i:
                return i[0]
        return None

    def manage_open_connection2(self, REQUEST=None):
        " "
        self.connect(self.connection_string)
        return self.manage_main(self, REQUEST)

        
    def manage_get_table_infos(self,tablename):
        " "
        if self._v_connected:
            o,r = self._v_database_connection.query(table_infos % tablename)
            self.__set_table_fkeys(tablename)
            self.__set_table_pkeys(tablename)
        else:
            return []
        
        result = []

        for item in r:
            rsp = {}
            i = 0
            for item2 in o:
                rsp[item2['name']] = item[i]
                i = i + 1
            result.append(rsp)
        return result

    def manage_get_tables (self):
        " "
        if self._v_connected:
            o,r = self._v_database_connection.query("select tablename,tableowner from pg_tables where tableowner != 'postgres'")
        else:
            return []

        result = []
        for item in r:
            rsp = {}
            rsp['tablename'] = item[0]
            rsp['tableowner'] = item[1]
            result.append(rsp)
        return result

        
    def manage_attempts (self, attempts,seconds,REQUEST):
        " "
        self.attempts = attempts
        self.seconds = seconds
        self._v_database_connection.setAttempts(attempts,seconds)
        return self.manage_main(self,REQUEST)

    manage_main=HTMLFile('PoPyconnectionStatus', globals())

    manage_properties=HTMLFile('PoPyconnectionEdit', globals())

    def manage_edit(self, title, connection_string, connected=None, attempts=10,seconds=5,REQUEST=None):
        """Change connection"""
        
        self.edit(title, connection_string, connected)

        self.attempts = attempts
        self.seconds = seconds
        if self._v_connected:
	    self._v_database_connection.setAttempts(attempts,seconds)


        if REQUEST is not None:
            return MessageDialog(title='Edited',
                                 message='<strong>%s</strong> has been edited.' % self.id,
                                 action ='./manage_main',
                                 )

    def __setstate__(self, state):
        Globals.Persistent.__setstate__(self, state)
        if self.connection_string:
            try:
                self.connect(self.connection_string)
            except: pass

    def edit(self, title, connection_string, check=1):
        self.title=title
        self.connection_string=connection_string
        if check == 1:
            self.connect(connection_string)
                 
    manage_testForm = HTMLFile('PoPyconnectionTestForm', globals())
    
    def factory(self): return DB

    def sql_quote__(self, v, escapes={
        '\\': '\\\\',
        '\"': '\\\"',
        '\'': '\\\'',
        '\0': '\\0',
        '\n': '\\n',
        '\t': '\\t', 
        '\r': '\\r',
        '\b': '\\n',
        }):
        find=string.find
        for c in "\\\"\'\0\n\t\r\b":
            if find(v,c) > -1:
                v=string.join(string.split(v,c),escapes[c])
        return "'%s'" % v
